| Disk ARchive 2.7.12 Full featured and portable backup and archiving tool

Public Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::trontextual Class Reference
Private

trontextual class is a contextual class tronc, that's all. More...

`#include <trontextual.hpp>`

Inherits libdar::tronc, and libdar::contextual.

## Public Member Functions
| trontextual (generic_file *f, const infinint &offset, const infinint &size, bool own_f=false)
| trontextual (generic_file *f, const infinint &offset, const infinint &size, gf_mode mode, bool own_f=false)
| trontextual (const trontextual &ref)=delete
| trontextual (trontextual &&ref) noexcept=delete
trontextual & | operator= (const trontextual &ref)=delete
trontextual & | operator= (trontextual &&ref)=delete
virtual bool | is_an_old_start_end_archive () const override
| returns whether the archive is a old archive (format < 8) More...
virtual const label & | get_data_name () const override
| obtain the data_name of the archive (label associated with the archive's data) More...
Public Member Functions inherited from libdar::tronc
| tronc (generic_file *f, const infinint &offset, const infinint &size, bool own_f=false)
| constructor More...
| tronc (generic_file *f, const infinint &offset, const infinint &size, gf_mode mode, bool own_f=false)
| tronc (generic_file *f, const infinint &offset, bool own_f=false)
| tronc (generic_file *f, const infinint &offset, gf_mode mode, bool own_f=false)
| tronc (const tronc &ref)=delete
| tronc (tronc &&ref) noexcept=delete
tronc & | operator= (const tronc &ref)=delete
tronc & | operator= (tronc &&ref)=delete
| ~tronc ()
| destructor More...
void | modify (const infinint &new_offset, const infinint &new_size)
| modify the tronc object to zoom on another (size limited) portion of the underlying object
void | modify (const infinint &new_offset)
| modify the tronc object to zoom on another (size unlimited) portion of the underlying object
void | modify ()
| modify the tronc object to become transparent and allow unrestricted access to the underlyuing object More...
virtual bool | skippable (skippability direction, const infinint &amount) override
| inherited from generic_file More...
virtual bool | skip (const infinint &pos) override
| inherited from generic_file More...
virtual bool | skip_to_eof () override
| inherited from generic_file More...
virtual bool | skip_relative (S_I x) override
| inherited from generic_file More...
virtual bool | truncatable (const infinint &pos) const override
| inherited from generic_file More...
virtual infinint | get_position () const override
| get the current read/write position More...
void | check_underlying_position_while_reading_or_writing (bool mode)
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor More...
| generic_file (const generic_file &ref)
| copy constructor More...
| generic_file (generic_file &&ref) noexcept
| move constructor More...
generic_file & | operator= (const generic_file &ref)
| assignment operator More...
generic_file & | operator= (generic_file &&ref) noexcept
| move operator More...
| ~generic_file () noexcept(false)
| virtual destructor, More...
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object More...
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file More...
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file More...
void | write (const std::string &arg)
| write a string to the generic_file More...
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char More...
virtual bool | skippable (skippability direction, const infinint &amount)=0
| whether the implementation is able to skip More...
virtual bool | skip (const infinint &pos)=0
| skip at the absolute position More...
virtual bool | skip_to_eof ()=0
| skip to the end of file More...
virtual bool | skip_relative (S_I x)=0
| skip relatively to the current position More...
virtual bool | truncatable (const infinint &pos) const =0
| whether the implementation is able to truncate to the given position More...
virtual void | truncate (const infinint &pos)
| truncate file at the given offset More...
virtual infinint | get_position () const =0
| get the current read/write position More...
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument More...
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data More...
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument More...
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data More...
bool | crc_status () const
| to known whether CRC calculation is activated or not More...
crc * | get_crc ()
| get CRC of the transfered date since last reset More...
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor More...
virtual U_I | read (char *a, U_I size)=0
| read data from the proto_generic_file More...
virtual void | write (const char *a, U_I size)=0
| write data to the proto_generic_file More...
Public Member Functions inherited from libdar::contextual
| contextual (const contextual &ref)=default
| contextual (contextual &&ref) noexcept=default
contextual & | operator= (const contextual &ref)=default
contextual & | operator= (contextual &&ref) noexcept=default
virtual void | set_info_status (const std::string &s)
| defines the new contextual value More...
virtual std::string | get_info_status () const
| get the current contextual value More...
virtual bool | is_an_old_start_end_archive () const =0
| returns whether the archive is a old archive (format < 8) More...
virtual const label & | get_data_name () const =0
| obtain the data_name of the archive (label associated with the archive's data) More...

## Private Member Functions
void | init (generic_file *f)

## Private Attributes
contextual * | ref
| this is just a pointer to data owned by the inherited class tronc part of this object More...

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }
Protected Member Functions inherited from libdar::tronc
virtual void | inherited_read_ahead (const infinint &amount) override
| inherited from generic_file More...
virtual U_I | inherited_read (char *a, U_I size) override
| inherited from generic_file More...
virtual void | inherited_write (const char *a, U_I size) override
| inherited from generic_file More...
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset More...
virtual void | inherited_sync_write () override
| write down any pending data More...
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position More...
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions More...
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
virtual void | inherited_read_ahead (const infinint &amount)=0
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data More...
virtual U_I | inherited_read (char *a, U_I size)=0
| implementation of read() operation More...
virtual void | inherited_write (const char *a, U_I size)=0
| implementation of the write() operation More...
virtual void | inherited_truncate (const infinint &pos)=0
| truncate file at the give offset More...
virtual void | inherited_sync_write ()=0
| write down any pending data More...
virtual void | inherited_flush_read ()=0
| reset internal engine, flush caches in order to read the data at current position More...
virtual void | inherited_terminate ()=0
| destructor-like call, except that it is allowed to throw exceptions More...
bool | is_terminated () const

## Detailed Description

trontextual class is a contextual class tronc, that's all.

Definition at line 44 of file trontextual.hpp.

## Member Function Documentation

## ◆ get_data_name()

virtual const label & libdar::trontextual::get_data_name | ( |  | ) | const
| inline override virtual

obtain the data_name of the archive (label associated with the archive's data)

Note
  label are conserved with dar_xform and archive isolation, but are not with archive merging or archive creation (full or differential backup)

Implements libdar::contextual.

Definition at line 56 of file trontextual.hpp.

References ref.

## ◆ is_an_old_start_end_archive()

virtual bool libdar::trontextual::is_an_old_start_end_archive | ( |  | ) | const
| inline override virtual

returns whether the archive is a old archive (format < 8)

Implements libdar::contextual.

Definition at line 55 of file trontextual.hpp.

References ref.

## Member Data Documentation

## ◆ ref

contextual* libdar::trontextual::ref
| private

this is just a pointer to data owned by the inherited class tronc part of this object

Definition at line 59 of file trontextual.hpp.

Referenced by get_data_name(), and is_an_old_start_end_archive().

The documentation for this class was generated from the following file:

- trontextual.hpp